
package de.ivu.elect.presentation.gruppe;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gruppe.boundary.PolitischeGruppeBoundaryCreate;
import de.ivu.elect.business.gruppe.boundary.PolitischeGruppeFactory;
import de.ivu.elect.business.gruppe.entity.PolitischeGruppe;
import de.ivu.elect.business.gruppe.entity.PolitischeGruppeMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractPolitischeGruppeCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractPolitischeGruppeCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.POLITISCHE_GRUPPE_CREATE)
public abstract class AbstractPolitischeGruppeCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<PolitischeGruppe> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "politischeGruppeCreateView";

  public static final String VIEW_ID = "/gruppe/politische-gruppe-create.xhtml";

  public static final String PARENT_VIEW_ID = "/gruppe/politische-gruppe-search.xhtml";

  @Inject
  protected transient PolitischeGruppeBoundaryCreate create;

  protected PolitischeGruppe entity;

  @Inject
  protected transient PolitischeGruppeMeta entityMeta;

  
  @Inject
  protected transient PolitischeGruppeFactory factory;

  public AbstractPolitischeGruppeCreateNoScopeView() {
    super();
  }

  @PostConstruct
  public void init() {
    setEntity(factory.create());
  }

  

  public PolitischeGruppe getEntity() {
    return entity;
  }

  protected void setEntity(PolitischeGruppe entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.POLITISCHE_GRUPPE_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(PolitischeGruppe entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(PolitischeGruppe entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.POLITISCHE_GRUPPE_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
